package cn.net.caoyao.cpzshandset.service.thread.impl.common;

import java.io.IOException;
import java.net.BindException;
import java.net.ConnectException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.List;

import android.os.Handler;
import android.os.Message;
import cn.net.caoyao.cpzshandset.bean.ActivateBean;
import cn.net.caoyao.cpzshandset.bean.SaleBean;
import cn.net.caoyao.cpzshandset.bean.SingleLabelOptionBean;
import cn.net.caoyao.cpzshandset.bean.UploadBean;
import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.HandsetOperation;
import cn.net.caoyao.cpzshandset.common.config.InternalOptionConstant;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.common.config.TConfig;
import cn.net.caoyao.cpzshandset.common.util.LogUtil;
import cn.net.caoyao.cpzshandset.service.bll.DealerOutBll;
import cn.net.caoyao.cpzshandset.service.bll.SingleLabelBll;
import cn.net.caoyao.cpzshandset.service.bll.UploadStatusBll;
import cn.net.cpzslibs.prot.Prot02Logout;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.bean.res.ProtStatusResBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20017ReqBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20027ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20017LabelBean;
import cn.net.cpzslibs.prot.handset.newProt.Prot20017CheckLabelStatus;
import cn.net.cpzslibs.prot.handset.newProt.Prot20076SubmitDealerOut;

public class CommonSubmitSingleDealerOutThread implements Runnable {
	private long deviceId;
	private DealerOutBll bll;
	private SingleLabelBll labelBll;
	private UploadStatusBll uploadStatusBll;
	private SaleBean saleBean;
	private List<SingleLabelOptionBean> singleOptions;
	private HandsetOperation option_type = HandsetOperation.OPERATION_DEALER_OUT_CONSTANT;
	private Handler mHandler;

	public CommonSubmitSingleDealerOutThread(Handler mHandler, long deviceId, DealerOutBll bll, SingleLabelBll labelBll,
			UploadStatusBll uploadStatusBll, SaleBean saleBean, List<SingleLabelOptionBean> singleOptions) {
		this.mHandler = mHandler;
		this.deviceId = deviceId;
		this.bll = bll;
		this.uploadStatusBll = uploadStatusBll;
		this.saleBean = saleBean;
		this.singleOptions = singleOptions;
		this.labelBll = labelBll;
	}

	@Override
	public void run() {
		SocketCreate create = new SocketCreate(Config.ip, Config.port, "");
		try {
			LogUtil.d(TConfig.Echo, "登录");
			create.createLoginCpzsHandset(deviceId);
			if (create.isResult()) {
				submitDealerOutInfo(create);
			} else {
				Message msg = new Message();
				msg.what = RequestConstant.REQUEST_PROT01_LOGIN_FAIL;
				msg.arg1 = create.getiErrCode();
				msg.obj = create.getErrMsg();
				mHandler.sendMessage(msg);
			}

		} catch (BindException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (ConnectException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (SocketTimeoutException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT);
		} catch (UnknownHostException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (IOException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} finally {
			new Prot02Logout().dealLogout(create);
		}
	}

	private void submitDealerOutInfo(SocketCreate create) throws IOException, SocketTimeoutException {
		Prot20076SubmitDealerOut activate = new Prot20076SubmitDealerOut();
		activate.submitDealerOut(create, getReqBean());
		ProtStatusResBean resBean = activate.getResBean();
		if (resBean == null) {
			mHandler.sendEmptyMessage(RequestConstant.SUBMIT_ACTIVATE_WITHOUT_RES);
			return;
		}

		if (resBean.getResult() == 0) {
			// 上传成功，插入记录到提交状态表
			uploadStatusBll.insertUploadStatus(getUploadBean(saleBean));
			bll.deleteSalesById(saleBean);
		} else {
			bll.updateSalesSubmitStatus(Config.SUBMIT_STATUS_SUBMIT_FAIL, resBean.getErrcode(), saleBean.getId());
			checkLabel(create, saleBean);
		}
		Message msg = mHandler.obtainMessage(RequestConstant.SUBMIT_ACTIVATE_WITH_RES);
		msg.obj = resBean;
		msg.what = RequestConstant.SUBMIT_ACTIVATE_WITH_RES;
		mHandler.sendMessage(msg);

	}
	

	private Prot20017ReqBean getProt20017ReqBean(ActivateBean activateBean) {
		Prot20017ReqBean reqBean = new Prot20017ReqBean();
		reqBean.setLabels(getLabels());
		reqBean.setOpt(8);
		return reqBean;
	}


	private UploadBean getUploadBean(SaleBean saleBean) {
		UploadBean b = new UploadBean();
		b.setLabel_count(labelBll.queryLabelCountById(option_type.getOption(), saleBean.getId()));
		b.setOption_type(option_type.getOption());
		return b;
	}

	private Prot20027ReqBean getReqBean() {
		Prot20027ReqBean reqBean = new Prot20027ReqBean();
		reqBean.setOpt(1);//1是出库 2是返库
		reqBean.setFlag(saleBean.getOption_mode());
		reqBean.setArea_id(saleBean.getSales_area());
		reqBean.setDealer_id((int)saleBean.getDealer_id());
		reqBean.setActual_num(saleBean.getPlan_num());
		reqBean.setRemark(saleBean.getDescribe());
		reqBean.setSingle(getLabels());
		reqBean.setCreate_time(saleBean.getCreateDate());
//		LogUtil.e(TConfig.Echo, "单标上次："+ reqBean.toString());
		return reqBean;
	}

	private List<String> getLabels() {
		List<String> singles = new ArrayList<>();
		for (SingleLabelOptionBean sLBean : singleOptions) {
			singles.add(sLBean.getLabel_id());
		}
		return singles;
	}
	
	private void checkLabel(SocketCreate create,SaleBean b) throws IOException{
		Prot20017CheckLabelStatus prot20017 = new Prot20017CheckLabelStatus();
		prot20017.checkLabel(create, getProt20017ReqBean(b));
		if (prot20017.getResBean() != null && prot20017.getResBean().getResult() == 0) {
			List<Prot20017LabelBean> invilad = prot20017.getResBean().getLabel_invalid();
			if (invilad != null) {
				List<String> inviladLabel = new ArrayList<>();
				for (Prot20017LabelBean prot20017LabelBean : invilad) {
					inviladLabel.add(prot20017LabelBean.getLabel_id());
				}
				labelBll.updateLableStatusById(inviladLabel, option_type.getOption(), b.getId(), InternalOptionConstant.SINGLE_LABEL_STATUS_INVALID);
			}
			
			List<Prot20017LabelBean> noActivate = prot20017.getResBean().getLabel_not_active();
			if (noActivate != null) {
				List<String> noActivateLabel = new ArrayList<>();
				for (Prot20017LabelBean prot20017LabelBean : noActivate) {
					noActivateLabel.add(prot20017LabelBean.getLabel_id());
				}
				labelBll.updateLableStatusById(noActivateLabel, option_type.getOption(), b.getId(), InternalOptionConstant.SINGLE_LABEL_STATUS_NO_ACTIVATE);
			}
		}
		
	}
	private Prot20017ReqBean getProt20017ReqBean(SaleBean b) {
		Prot20017ReqBean reqBean = new Prot20017ReqBean();
		reqBean.setLabels(getLabels());
		reqBean.setOpt(getOptType());
		return reqBean;
	}
	
	//操作类型1-出库 2-入库 3-销售 4-返库 6-打包 8-激活
	private int getOptType() {
			int opt = 0;
			switch (option_type) {
			case OPERATION_ACTIVATE_CONSTANT:
				opt = 8;
				break;
			case OPERATION_DEALER_OUT_CONSTANT:
			case OPERATION_OUT_WAREHOUSE_CONSTANT:
				opt = 1;
				break;
			case OPERATION_IN_WAREHOUSE_CONSTANT:
				opt = 2;
				break;
			case OPERATION_SALE_CONSTANT:
				opt = 3;
				break;
			case OPERATION_BACK_WAREHOUSE_CONSTANT:
				opt = 4;
				break;
			case OPERATION_PACK_CONSTANT:
				opt = 6;
				break;
			}
			return opt;
		}
}
